package kr.co.uracle.m_push_plugin.receiver;

import android.util.Log;

import com.google.firebase.messaging.FirebaseMessagingService;
import com.google.firebase.messaging.RemoteMessage;

import m.client.push.library.PushMessagingManager;
import m.client.push.library.common.Logger;
import m.client.push.library.utils.PushUtils;

/**
 * mpush 외의 다른 FCM 푸시를 사용하는 경우, FirebaseMessagingService 커스텀 필요시
 * **/
public class CustomMessagingService extends FirebaseMessagingService {
	@Override
	public void onNewToken(String s) {
		super.onNewToken(s);
		PushMessagingManager.getInstance().newToken(getApplicationContext());
	}

	@Override
	public void onMessageReceived(RemoteMessage remoteMessage) {
		super.onMessageReceived(remoteMessage);
		//전체 FCM 푸시에 대해 수신된 데이터를 로그로 출력.

		if(PushUtils.isMPush(remoteMessage)) {
			Log.d("RemoteMessage_Log",remoteMessage.getData().toString());
			PushMessagingManager.getInstance().messageReceived(getApplicationContext(), remoteMessage);
		}
		else{
			//ARS 푸시 처리
		}
	}
}
