package com.example.test_plugin_ft1

import android.content.Intent
import io.flutter.embedding.android.FlutterActivity
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.plugins.GeneratedPluginRegistrant
import kr.co.uracle.m_push_plugin.mpush.MPushPlugin
import org.json.JSONException
import org.json.JSONObject

class MainActivity: FlutterActivity() {
    override fun configureFlutterEngine(flutterEngine: FlutterEngine) {
        super.configureFlutterEngine(flutterEngine)
        GeneratedPluginRegistrant.registerWith(flutterEngine)
    }

    //app 실행 중 푸시 수신시 후처리
    override fun onNewIntent(intent: Intent) {
        super.onNewIntent(intent)
        var notification = intent.getStringExtra("JSON")
        val payload = JSONObject()
        try {
            payload.put("status", "SUCCESS")
            payload.put("payload", notification)
        } catch (e: JSONException) {
            throw java.lang.RuntimeException(e)
        }
        val map: MutableMap<String, Any> = java.util.HashMap()
        val keysItr = payload.keys()
        while (keysItr.hasNext()) {
            val key = keysItr.next()
            var value: Any
            value = try {
                payload[key]
            } catch (e: JSONException) {
                throw java.lang.RuntimeException(e)
            }
            map[key] = value
        }
        MPushPlugin.channel.invokeMethod("pushMessage", map)
    }
}
