package kr.co.uracle.m_push_plugin.receiver;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;


import org.json.JSONObject;

import kr.co.uracle.m_push_plugin.notification.PushNotificationManager;
import m.client.push.library.PushManager;
import m.client.push.library.common.PushConstants;
import m.client.push.library.common.PushLog;

/**
 * MessageArrivedReceiver
 * 메세지 수신 처리를 위해 등록된 리시버
 */
public class MessageArrivedReceiver extends BroadcastReceiver {

	@Override   
	public void onReceive(Context context, Intent intent) {
		PushLog.d("onReceive", "[Callback] receive action");
		 if (intent.getAction().equals(context.getPackageName() + PushConstants.ACTION_GCM_MESSAGE_ARRIVED)) {
			try {
				if (intent.getAction().equals(context.getPackageName() + PushConstants.ACTION_GCM_MESSAGE_ARRIVED)) {
					// 디바이스 Badge 값 변경
					final String jsonData = intent.getExtras().getString("JSON");
					final String encryptData = intent.getExtras().getString(PushConstants.KEY_ORIGINAL_PAYLOAD_STRING);
					JSONObject jsonMsg = new JSONObject(jsonData);
					//JSONObject aps = jsonMsg.getJSONObject("aps");
					JSONObject aps = jsonMsg.getJSONObject("aps");
					final String badgeNo = aps.getString("badge");
					try {
						if (!TextUtils.isEmpty(badgeNo) && Integer.parseInt(badgeNo) > 0) {
							PushManager.getInstance().setDeviceBadgeCount(context, badgeNo);
						}
					}
					catch(NumberFormatException e) {
						// 존재하지 않거나 0보다 작다면 무시..
					}
					PushNotificationManager.createNotification(context, intent, PushConstants.STR_GCM_PUSH_TYPE);
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
