import 'package:flutter_test/flutter_test.dart';
import 'package:m_push_plugin/m_push_plugin.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockMPushPluginPlatform
    with MockPlatformInterfaceMixin
    implements MPushPluginPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final MPushPluginPlatform initialPlatform = MPushPluginPlatform.instance;

  test('$MethodChannelMPushPlugin is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelMPushPlugin>());
  });

  test('getPlatformVersion', () async {
    MPushPlugin mPushPlugin = MPushPlugin();
    MockMPushPluginPlatform fakePlatform = MockMPushPluginPlatform();
    MPushPluginPlatform.instance = fakePlatform;

    expect(await mPushPlugin.getPlatformVersion(), '42');
  });
}
